--[[
--Marathon Broomball, by Jon Irons.
--A lot of code borrowed from:
--CTF/Lua v1.1
--By Darren Watts (W'rkncacnter)
--]]

POINTS = 7
teams = {}
goals={};
count1 = 0
count2 = 0
wait = 1
score = false;
points = {}
kills = {}
original_teams = {}
original_colors = {}
colors={}
colors[1] = 1;
colors[2] = 6;
finish_off = false
end_timer = 0
has_ended = false

function init()
	set_base_polys()
	initialize_vars()
	check_teams()
end

function initialize_vars()
	PUCK_INDEX = new_monster(_monster_minor_defender, PUCK_POLY);
	local xy, yz, zx = get_monster_position(PUCK_INDEX);
	xy = xy/1024;
	yz = yz/1024;
	for i = 1, number_of_players(), 1 do
		points[i] = 0
		kills[i] = {}
		for k = 1, number_of_players()-1, 1 do
			kills[i][k] = 0
		end
		set_lua_compass_state(i, _network_compass_use_beacon);
		set_lua_compass_beacon(i, xy, yz);
		use_lua_compass(i, true);
	end
	to_goals();
end

function set_base_polys()
	for i = 0, number_of_polygons() - 1, 1 do
		local tp = get_polygon_type(i);
		if(tp == _polygon_is_dual_monster_trigger) then
			goals[1] = i
		end
		if(tp == _polygon_must_be_explored) then
			goals[2] = i
		end
	
		if (tp == _polygon_is_zone_border) then
			PUCK_POLY = i;
		end
	end
end

function check_teams()
	local red_team_exists = false
	local blue_team_exists = false
	for i = 0, number_of_players() - 1, 1 do
		if(get_player_team(i) == colors[1]) then
			red_team_exists = true
		elseif(get_player_team(i) == colors[2]) then
			blue_team_exists = true
		end
	end
	if(red_team_exists == false and blue_team_exists == false) then
		assign_teams(0)
	elseif(red_team_exists == true and blue_team_exists == false) then
		assign_teams(1)
	elseif(red_team_exists == false and blue_team_exists == true) then
		assign_teams(2)
	else
		assign_teams(3)
	end
end

function assign_teams(num)
	if(num == 0) then
		num = math.mod (better_random (), number_of_players())
		teams[1] = get_player_team(num)
		for i = 0, number_of_players() - 1, 1 do --Split into teams.
			if (get_player_team(i) ~= teams[1]) then
				teams[table.getn(teams) + 1] = get_player_team(i)
			end
		end
		for i = 0, number_of_players() - 1, 1 do
			if (get_player_team(i) == teams[1]) then
				set_player_team(i, colors[1])
				set_player_color(i, colors[1])
				original_teams[i+1] = colors[1]
				original_colors[i+1] = get_player_color(i)
			else
				set_player_team(i, colors[2])
				set_player_color(i, colors[2])
				original_teams[i+1] = colors[2]
				original_colors[i+1] = get_player_color(i)
			end
		end
	end
	if(num == 1 or num == 3) then
		for i = 0, number_of_players() - 1, 1 do
			if (get_player_team(i) == colors[1]) then
				set_player_team(i, colors[1])
				set_player_color(i, colors[1])
				original_teams[i+1] = colors[1]
				original_colors[i+1] = get_player_color(i)
			else
				set_player_team(i, colors[2])
				set_player_color(i, colors[2])
				original_teams[i+1] = colors[2]
				original_colors[i+1] = get_player_color(i)
			end
		end
	end
	if(num == 2) then
		for i = 0, number_of_players() - 1, 1 do
			if(get_player_team(i) == colors[2]) then
				set_player_team(i, colors[2])
				set_player_color(i, colors[2])
				original_teams[i+1] = colors[2]
				original_colors[i+1] = get_player_color(i)
			else
				set_player_team(i, colors[1])
				set_player_color(i, colors[1])
				original_teams[i+1] = colors[1]
				original_colors[i+1] = get_player_color(i)
			end
		end
	end
	teams[1] = colors[1]
	teams[2] = colors[2]
end

function idle()
	score_procedure();
	update_count()
	local xy, yz, zx = get_monster_position(PUCK_INDEX);
	xy = xy/1024;
	yz = yz/1024;
	local ghgh;
	for ghgh=0, number_of_players()-1, 1 do
		set_lua_compass_state(ghgh, _network_compass_use_beacon);
		set_lua_compass_beacon(ghgh, xy, yz);
		use_lua_compass(ghgh, true);
	end
	end_game()
end

function update_count()
	if(count1 > 0) then
		count1 = count1 - 1
	end
	if(count2 > 0) then
		count2 = count2 - 1
	end
	if(end_timer > 0) then
		end_timer = end_timer - 1
	end
	if(wait >= -1) then
		wait = wait - 1
	end
end

function check_if_end_game(num)
	local total_points = 0
	for i = 0, number_of_players() - 1, 1 do
		if(original_teams[i+1] == teams[num]) then
			total_points = total_points + points[i+1]
		end
	end
	if(total_points >= POINTS) then
		if(num == 1) then team = "RED" else team = "BLUE" end
		screen_print(" ")
		screen_print(team .. " team wins!")
		finish_off = true
		end_timer = 100
	end
end

function end_game()
	if(finish_off == true and end_timer <= 0 and has_ended == false) then
		for i = 0, number_of_players() - 1, 1 do
			 teleport_player_to_level (i, 256)
		end
		has_ended = true
	end
end

function score_procedure()
	local puck_location = get_monster_polygon(PUCK_INDEX);
	if (not score) then
		local recur;
		for recur=1, table.getn(goals), 1 do
			if (goals[recur] == puck_location) then
				local roo;
				for roo=0, number_of_players()-1, 1 do
					play_sound(roo, _snd_alarm, 1);
				end
				points[recur] = points[recur] + 1;
				screen_print("Red: "..points[1].."    Blue: "..points[2]);
				score = true;
				set_monster_vitality(PUCK_INDEX, 0);
				damage_monster(PUCK_INDEX, 1, _damage_explosion);
			end
		end
	end
end

function monster_killed(monster, aggressor_player, projectile)
	if (monster == PUCK_INDEX) then
		PUCK_INDEX = new_monster(_monster_minor_defender, PUCK_POLY);
		score = false;
		to_goals();
	end
end

function to_goals()
	local gg;
	for gg=0, number_of_players()-1, 1 do
		if (get_player_team(gg) == colors[1]) then
			teleport_player(gg, goals[2]);
		else
			teleport_player(gg, goals[1]);
		end
	end
end